<?php

namespace DataView;

class Fop_mail_host_box_draft {
  
  

  
  

    // --- Statische Methoden ---
  
  public static function renderScript() { 
    
    
    // --- BLOCK: main ---
    
								\FOP\I18n::ensureIsLoaded();
								?>
								<script type="text/javascript">
									
    function changefilter_fop_mail_host_box_draft_mailboxListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_fop_mail_host_box_draft_mailbox', val, cb.checked);
		  } else {
			  delete query['filter_fop_mail_host_box_draft_mailbox'];
		  }reloadfop_mail_host_box_draft();
        
    }

		var ibc96441f8ceb42ea7f1a3c4603467f4e50453714c2d153b8e18e51827a54b318timeout = null;
		function changefilter_fop_mail_host_box_draft_mailboxSearchFilter(val, callback) {
			if(ibc96441f8ceb42ea7f1a3c4603467f4e50453714c2d153b8e18e51827a54b318timeout) clearTimeout(ibc96441f8ceb42ea7f1a3c4603467f4e50453714c2d153b8e18e51827a54b318timeout);

			ibc96441f8ceb42ea7f1a3c4603467f4e50453714c2d153b8e18e51827a54b318timeout = setTimeout(function() {
				$.getJSON(reloadfop_mail_host_box_draft({action: 'getfilter_fop_mail_host_box_draft_mailboxItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_fop_mail_host_box_draft_mailbox_orig'] = val;
				});
			}, 300);
		}

	function getfilter_fop_mail_host_box_draft_mailboxListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_fop_mail_host_box_draft_mailbox_orig']) ? json_encode($_GET['filter_fop_mail_host_box_draft_mailbox_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="bc96441f8ceb42ea7f1a3c4603467f4e50453714c2d153b8e18e51827a54b318" type="text">' +
			'<label class="mdl-textfield__label" for="bc96441f8ceb42ea7f1a3c4603467f4e50453714c2d153b8e18e51827a54b318">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_fop_mail_host_box_draft_mailbox', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_fop_mail_host_box_draft_mailbox_orig'] = '';
					delete query['filter_fop_mail_host_box_draft_mailbox'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadfop_mail_host_box_draft();
					
				} else {
					$('#table_fop_mail_host_box_draft').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_fop_mail_host_box_draft_mailboxSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\Fop_mail_host_box_draft::getfilter_fop_mail_host_box_draft_mailboxItemsByStringAction(''));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_fop_mail_host_box_draft_mailbox_orig'] = '';
				delete query['filter_fop_mail_host_box_draft_mailbox'];
				reload('', items);reloadfop_mail_host_box_draft();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_fop_mail_host_box_draft_mailbox', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_fop_mail_host_box_draft_mailboxListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
									
    function changefilter_fop_mail_host_box_draft_mailboxListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_fop_mail_host_box_draft_mailbox', val, cb.checked);
		  } else {
			  delete query['filter_fop_mail_host_box_draft_mailbox'];
		  }reloadfop_mail_host_box_draft();
        
    }

		var ibc96441f8ceb42ea7f1a3c4603467f4e50453714c2d153b8e18e51827a54b318timeout = null;
		function changefilter_fop_mail_host_box_draft_mailboxSearchFilter(val, callback) {
			if(ibc96441f8ceb42ea7f1a3c4603467f4e50453714c2d153b8e18e51827a54b318timeout) clearTimeout(ibc96441f8ceb42ea7f1a3c4603467f4e50453714c2d153b8e18e51827a54b318timeout);

			ibc96441f8ceb42ea7f1a3c4603467f4e50453714c2d153b8e18e51827a54b318timeout = setTimeout(function() {
				$.getJSON(reloadfop_mail_host_box_draft({action: 'getfilter_fop_mail_host_box_draft_mailboxItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_fop_mail_host_box_draft_mailbox_orig'] = val;
				});
			}, 300);
		}

	function getfilter_fop_mail_host_box_draft_mailboxListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_fop_mail_host_box_draft_mailbox_orig']) ? json_encode($_GET['filter_fop_mail_host_box_draft_mailbox_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="bc96441f8ceb42ea7f1a3c4603467f4e50453714c2d153b8e18e51827a54b318" type="text">' +
			'<label class="mdl-textfield__label" for="bc96441f8ceb42ea7f1a3c4603467f4e50453714c2d153b8e18e51827a54b318">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_fop_mail_host_box_draft_mailbox', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_fop_mail_host_box_draft_mailbox_orig'] = '';
					delete query['filter_fop_mail_host_box_draft_mailbox'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadfop_mail_host_box_draft();
					
				} else {
					$('#table_fop_mail_host_box_draft').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_fop_mail_host_box_draft_mailboxSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\Fop_mail_host_box_draft::getfilter_fop_mail_host_box_draft_mailboxItemsByStringAction(''));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_fop_mail_host_box_draft_mailbox_orig'] = '';
				delete query['filter_fop_mail_host_box_draft_mailbox'];
				reload('', items);reloadfop_mail_host_box_draft();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_fop_mail_host_box_draft_mailbox', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_fop_mail_host_box_draft_mailboxListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
									function updateNumberfop_mail_host_box_draft(col) {
										//var checklist = window.DataViewChecked['fop_mail_host_box_draft'][col];
										//if (checklist.id) {
											// checklist is online
											// TODO: check if cache is alive, otherwise reload from ajax, delay execution and return now
											//checklist.ranges = [[1,10000000]]; // mostly we use indirect idlists to tick all marks; so this is an approximation
										//}
										// checkboxes aktualisieren
										if (window.DataViewChecked && window.DataViewChecked['fop_mail_host_box_draft'] && window.DataViewChecked['fop_mail_host_box_draft'][col].ranges.length > 0) {
											$('.fop_mail_host_box_draft__mass-action').css('visibility', 'visible');
											$('.fop_mail_host_box_draft__action').css('visibility', 'hidden');
										} else {
											$('.fop_mail_host_box_draft__mass-action').css('visibility', 'hidden');
											$('.fop_mail_host_box_draft__action').css('visibility', 'visible');
										}
										$('.fop_mail_host_box_draft__checkbox').each(function (idx, x) {
											for (var cssclass of x.classList) {
												if (cssclass.startsWith('fop_mail_host_box_draft__checkbox-'+col+'-')) {
													var my_id = cssclass.substr(('fop_mail_host_box_draft__checkbox-'+col+'-').length);
													if (window.DataViewChecked) {
														x.MaterialCheckbox[checklist.has(my_id) ? 'check' : 'uncheck']();
													}
												}
											}
										});
									}
									function reloadfop_mail_host_box_draft (params, returnUrl, onlyScroll, addPadding = 0) {
										// copy query
										let nq = JSON.parse(JSON.stringify(query));
										nq['parent_request'] = <?php echo json_encode(strtok(\FOP\Util::getBackUrl(), '?')); ?>;
										<?php if (isset($_GET['select'])) { ?>nq['select'] = 'select';<?php } ?>
										
										if (params) {
											for (var i in params) nq[i] = params[i];
											var action = nq['action'];
											delete nq['action'];
											let querystr = "DataView/Fop_mail_host_box_draft/" + action + "?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// direkt aufrufen (ist wohl ein Download oder so)
											if (returnUrl) return querystr;
											window.location.href = querystr;
										} else {
											let querystr;
											
											
											<?php if ((!\FOP\User::getIsGuest()) && (!\FOP\User::getIsGuest())) { ?>
											delete nq['action'];
											querystr = "DataView/Fop_mail_host_box_draft/renderTabTable?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// per Ajax laden
											if(!$("#fop_mail_host_box_draft-table")?.parent()?.parent()?.hasClass('fop-form-feature-collapsed') || $("#fop_mail_host_box_draft-table")?.parent()?.parent()?.hasClass('fop-form-feature-mode-area')) {
											$.get(querystr, function(data){
												var tab = $("#fop_mail_host_box_draft-table");
												var top = tab.find('.fop-table-body-inner');
												var el;
												if (onlyScroll && (el = $('<div class="tabcontent">' + data + '</div>').find('.fop-table-body-inner'))) {
													// nur Scroll-Bereich ersetzen
													var paddingTop = parseInt(el.css('paddingTop') || '0px', 10);
													var minHeight = parseInt(el.css('minHeight'), 10)
													paddingTop += addPadding;
													minHeight += addPadding;
													top.css({paddingTop: paddingTop.toString()+'px', minHeight: minHeight.toString()+'px'}); // Offset
													el = el.children();
													top.empty();
													top.append(el);
													el = top; // top-upgrade doppelt machen, dadurch vermeiden wir das Array-upgrade => Performance
												} else {
													// gesamten Tab ersetzen
													tab.children().remove();
													el = tab.html('<div class="tabcontent">' + data + '</div>');
												}
												try {
													for (var i = 0; i < el.length; i++) upgradeDOM(el[i]);
												} catch (e) {
													console.log(e);
												}
												upgradeTable(el.find('.fop-table .fop-table-header')); // Falls es Tabellen-Layout ist: Spalten-Order anpassen
												flushURL(); // Neue URL in Titelleiste eintragen

												// Checkbox-Auswahl ankreuzen
												updateNumberfop_mail_host_box_draft('ID');
											});
											} else {
												// gesamten Tab ersetzen
												var tab = $("#fop_mail_host_box_draft-table");
												tab.children().remove();
												el = tab.html('<div class="fop-lazy-reload" onclick="reloadfop_mail_host_box_draft()"></div>');
											}
											<?php } ?>
											
										}
									}
									function checkfop_mail_host_box_draft (id, col, checked) {
										// ID-Liste aufbauen
										if (!window.DataViewChecked) window.DataViewChecked = {};
										if (!window.DataViewChecked['fop_mail_host_box_draft']) window.DataViewChecked['fop_mail_host_box_draft'] = {};
										if (!window.DataViewChecked['fop_mail_host_box_draft'][col]) window.DataViewChecked['fop_mail_host_box_draft'][col] = new IDList();

										// Abfrage aller gecheckten IDs für eine Tabelle
										if (!id) {
											return window.DataViewChecked['fop_mail_host_box_draft'][col].toString();
										}

										// check all, check id
										if (id == 'all') {
											// TODO: umbauen #1289: 'all' auch nur auf ne idlist reduzieren
											if (checked) {
												$.get(reloadfop_mail_host_box_draft({action: 'getids', col: col}, true), function (ids) {
													window.DataViewChecked['fop_mail_host_box_draft'][col] = new IDList(ids);
													updateNumberfop_mail_host_box_draft(col);
												});
											} else {
												window.DataViewChecked['fop_mail_host_box_draft'][col] = new IDList();
												updateNumberfop_mail_host_box_draft(col);
											}
										} else {
											var ids = new IDList(id);
											var allcb = $('#fop_mail_host_box_draft__all-checkbox');
											if (allcb[0]) {
												allcb[0].parentElement.MaterialCheckbox.uncheck(); // TODO: prüfen, ob Gruppen-CBs voll werden
											}
											if (checked == 'set') {
												window.DataViewChecked['fop_mail_host_box_draft'][col] = ids;
											} else for (id of ids.all()) {
												if (checked) {
													window.DataViewChecked['fop_mail_host_box_draft'][col].push(id);
												} else {
													window.DataViewChecked['fop_mail_host_box_draft'][col].remove(id);
												}
											}
											updateNumberfop_mail_host_box_draft(col);
										}
									}
								</script><?php

    
  }

  public static function renderSpecialFilters() { 
    
    
    // --- BLOCK: main ---
    ?>
	
	<script type"text/javascript">
		function updateSpecialFilter(param, val) {
			query[param] = val.toString();reloadfop_mail_host_box_draft();
			
		}

	</script>
	<?php
	
    
  }

  public static function renderTabTableAction() { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
     ?><div class='fop-dv-buttonbar'><?php if((!\FOP\User::getIsGuest()) && (!\FOP\User::getIsGuest()) && (!\FOP\User::getIsGuest())) { ?><a class="mdl-button mdl-js-button mdl-button--raised mdl-button--colored" onclick="
		var self = this;
		event.preventDefault();
		$.get(reloadfop_mail_host_box_draft({action: 'open', fop_table: 'fop_mail_host_box_draft', fop_id: '_', fop_from: location.href}, true))
		.then(function () {
			window.open_url(self.href, false);
		});" href="<?php echo htmlentities(\TablesRouter\Fop_mail_host_box_draft::createURL2(['from' => $_GET['from'] ?? null, 'popup' => $_GET['popup'] ?? null])); ?>"><i class="material-icons">add</i> <?php echo(sprintf(_('create %s'), _('draft'))); ?></a><?php } ?></div><?php 
								\FOP\User::getIsGuest();
								$itemheight = 32;
								$itemsperpage = ceil(1080 / $itemheight * 0.8);
								$page = (isset($_GET['page_fop_mail_host_box_draft']) ? intval($_GET['page_fop_mail_host_box_draft']) : 0);
								$addlines = (isset($_GET['addlines_fop_mail_host_box_draft']) ? intval($_GET['addlines_fop_mail_host_box_draft']) : 0);
								$firstitem = $page * $itemsperpage;
								$sqladdon = ' LIMIT ' . ($itemsperpage * 2) . ' OFFSET ' . ($firstitem);
								$data = self::getData($sqladdon, $_GET);
								$arr = $data["items"];
								$itemcount = $data["itemcount"];
								$lastPage = ceil($itemcount/$itemsperpage-1);
								// calculate width of first column: 67px + 32px for each shortcut
								$firstColumnWidth = 66 + 34 + 34;
								$additionalLines = 0;

									// Spaltenliste zuerst aufbauen, damit sie noch umsortiert werden kann
									$order = 1000;
									$columns = [];
									
										if(true){
											$col = [
												'id' => 'receiver',
												'desc' => _('recipient'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['receiver'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'mailbox',
												'desc' => _('mailbox'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['mailbox'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'subject',
												'desc' => _('subject'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['subject'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'date',
												'desc' => _('date'),
												'order' => ++$order,
												'width' => 160, // default value
												'collapsed' => 0

											];
											$columns['date'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'content',
												'desc' => _('content'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['content'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'contentSignature',
												'desc' => _('email_signature'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['contentSignature'] = $col;
										}
									

									// gespeicherte Spaltenanordnung
									foreach (\FOP\Database::query('SELECT * FROM fop_dataview WHERE '.qi('user').' = ' . \FOP\Database::quote(\FOP\User::getID()) . ' AND dataview = ' . \FOP\Database::quote('fop_mail_host_box_draft'))->fetchAll(\PDO::FETCH_ASSOC) AS $column => $c) {
										if (isset($columns[$c['column']])) {
											$columns[$c['column']]['order'] = $c['order']; // order, width, collapsed
											$columns[$c['column']]['width'] = $c['width']; // order, width, collapsed
											$columns[$c['column']]['collapsed'] = $c['collapsed']; // order, width, collapsed
										}
									}

									// DOM vor-rendern
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='receiver'
												data-order='<?php echo intval($columns['receiver']['order']); ?>'
												data-width='<?php echo intval($columns['receiver']['width']); ?>'
												data-collapsed='<?php echo intval($columns['receiver']['collapsed']); ?>'
												style='width: <?php echo intval($columns['receiver']['width']); ?>px; <?php if ($columns['receiver']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_mail_host_box_draft(); 
		}});
		
		var el = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label fop-floatsorter\' style=\'width: calc(100% - 42px);\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(_('search')); ?></label></div>');
		win.append(el);
		var text = el.find('input');
		text.val(query['search_fop_mail_host_box_draft_receiver'])
		text.on('change keyup paste', function () { if (text.val()) { query['search_fop_mail_host_box_draft_receiver'] = text.val(); } else { delete query['search_fop_mail_host_box_draft_receiver']; } changed = true; });
		text.focus();
		text.select();
		text.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_mail_host_box_draft').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});

		var el2 = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(htmlentities(htmlentities(_('filter_contains_not')))); ?></label></div>');
		win.append(el2);
		var text2 = el2.find('input');
		text2.val(query['searchnot_fop_mail_host_box_draft_receiver'])
		text2.on('change keyup paste', function () { if (text2.val()) { query['searchnot_fop_mail_host_box_draft_receiver'] = text2.val(); } else { delete query['searchnot_fop_mail_host_box_draft_receiver']; } changed = true; });
		text2.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_mail_host_box_draft').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});
	
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_mail_host_box_draft'] == 'receiver ASC') {
			query['sort_fop_mail_host_box_draft'] = 'receiver DESC';
		 } else if (query['sort_fop_mail_host_box_draft'] == 'receiver DESC') {
		 	delete query['sort_fop_mail_host_box_draft'];
		 } else {
			query['sort_fop_mail_host_box_draft'] = 'receiver ASC';
		 }
		 reloadfop_mail_host_box_draft();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('recipient')); ?>'><?php echo(_('recipient')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_mail_host_box_draft']) && $_GET['sort_fop_mail_host_box_draft'] == 'receiver ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_mail_host_box_draft']) && $_GET['sort_fop_mail_host_box_draft'] == 'receiver DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_mail_host_box_draft_receiver']) || isset($_GET['range_max_fop_mail_host_box_draft_receiver']) || isset($_GET['deps_fop_mail_host_box_draft_receiver']) || isset($_GET['fullsearch_fop_mail_host_box_draft_receiver']) || isset($_GET['dynamic_fop_mail_host_box_draft_receiver']) || isset($_GET['search_fop_mail_host_box_draft_receiver']) || isset($_GET['searchnot_fop_mail_host_box_draft_receiver']) || isset($_GET['filter_fop_mail_host_box_draft_receiver'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['receiver']['header'] = ob_get_contents(); ob_end_clean();
											$columns['receiver']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['receiver']['width']); ?>px; <?php if ($columns['receiver']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='receiver'><span class='overflow-text'><a onclick="event.stopPropagation();<?php if ((!\FOP\User::getIsGuest()) && (!\FOP\User::getIsGuest()) && (!\FOP\User::getIsGuest())) { ?>event.preventDefault(); window.open_over(document.baseURI + 'Tables/Fop_mail_host_box_draft/create?to=' + encodeURIComponent(this.href.substr(7)) + '&popup&from=' + encodeURIComponent(document.baseURI + 'jscloser.php?action=popup&close')); <?php } ?>
" href="<?php echo ('mailto:' . htmlentities(($item['receiver']))); ?>"><?php echo htmlentities($item['receiver']); ?></a></span></div><?php
											};
											$columns['receiver']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='receiver'
													data-order='<?php echo intval($columns['receiver']['order']); ?>'
													data-width='<?php echo intval($columns['receiver']['width']); ?>'
													data-collapsed='<?php echo intval($columns['receiver']['collapsed']); ?>'
													style='width: <?php echo intval($columns['receiver']['width']); ?>px; <?php if ($columns['receiver']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='mailbox'
												data-order='<?php echo intval($columns['mailbox']['order']); ?>'
												data-width='<?php echo intval($columns['mailbox']['width']); ?>'
												data-collapsed='<?php echo intval($columns['mailbox']['collapsed']); ?>'
												style='width: <?php echo intval($columns['mailbox']['width']); ?>px; <?php if ($columns['mailbox']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_mail_host_box_draft(); 
		}});
		
		win.append(getfilter_fop_mail_host_box_draft_mailboxListMultiFilter()); win.find('input').first().focus();
		return false;
	">
													<span class='title-title' title='<?php echo(_('mailbox')); ?>'><?php echo(_('mailbox')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_mail_host_box_draft']) && $_GET['sort_fop_mail_host_box_draft'] == 'mailbox ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_mail_host_box_draft']) && $_GET['sort_fop_mail_host_box_draft'] == 'mailbox DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_mail_host_box_draft_mailbox']) || isset($_GET['range_max_fop_mail_host_box_draft_mailbox']) || isset($_GET['deps_fop_mail_host_box_draft_mailbox']) || isset($_GET['fullsearch_fop_mail_host_box_draft_mailbox']) || isset($_GET['dynamic_fop_mail_host_box_draft_mailbox']) || isset($_GET['search_fop_mail_host_box_draft_mailbox']) || isset($_GET['searchnot_fop_mail_host_box_draft_mailbox']) || isset($_GET['filter_fop_mail_host_box_draft_mailbox'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['mailbox']['header'] = ob_get_contents(); ob_end_clean();
											$columns['mailbox']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['mailbox']['width']); ?>px; <?php if ($columns['mailbox']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='mailbox'><?php
	
	call_user_func(function () use ($item) {
	$id = $item['mailbox'];
	$val = $item['mailbox::description'];
	$canView = $item['mailbox::canView'];
	if ($val !== null) {
		if ($canView) echo "<a tabindex=\"-1\" class=\"mdl-button mdl-button-small tbl-link\" data-tbl=\"fop_mail_host_box\" data-id=\"".htmlentities($id)."\" onclick=\"event.stopPropagation(); event.preventDefault(); open_url(this.href, false);\" href=\"" . \TablesRouter\Fop_mail_host_box::viewURL($id, ['from' => \FOP\Util::getBackURL()]) . "\">(…)</a>";echo htmlentities($val);
	} else {
		echo htmlentities(_('') ?: '-');
	}
	});
	
?>
</div><?php
											};
											$columns['mailbox']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='mailbox'
													data-order='<?php echo intval($columns['mailbox']['order']); ?>'
													data-width='<?php echo intval($columns['mailbox']['width']); ?>'
													data-collapsed='<?php echo intval($columns['mailbox']['collapsed']); ?>'
													style='width: <?php echo intval($columns['mailbox']['width']); ?>px; <?php if ($columns['mailbox']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='subject'
												data-order='<?php echo intval($columns['subject']['order']); ?>'
												data-width='<?php echo intval($columns['subject']['width']); ?>'
												data-collapsed='<?php echo intval($columns['subject']['collapsed']); ?>'
												style='width: <?php echo intval($columns['subject']['width']); ?>px; <?php if ($columns['subject']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_mail_host_box_draft(); 
		}});
		
		var el = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label fop-floatsorter\' style=\'width: calc(100% - 42px);\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(_('search')); ?></label></div>');
		win.append(el);
		var text = el.find('input');
		text.val(query['search_fop_mail_host_box_draft_subject'])
		text.on('change keyup paste', function () { if (text.val()) { query['search_fop_mail_host_box_draft_subject'] = text.val(); } else { delete query['search_fop_mail_host_box_draft_subject']; } changed = true; });
		text.focus();
		text.select();
		text.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_mail_host_box_draft').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});

		var el2 = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(htmlentities(htmlentities(_('filter_contains_not')))); ?></label></div>');
		win.append(el2);
		var text2 = el2.find('input');
		text2.val(query['searchnot_fop_mail_host_box_draft_subject'])
		text2.on('change keyup paste', function () { if (text2.val()) { query['searchnot_fop_mail_host_box_draft_subject'] = text2.val(); } else { delete query['searchnot_fop_mail_host_box_draft_subject']; } changed = true; });
		text2.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_mail_host_box_draft').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});
	
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_mail_host_box_draft'] == 'subject ASC') {
			query['sort_fop_mail_host_box_draft'] = 'subject DESC';
		 } else if (query['sort_fop_mail_host_box_draft'] == 'subject DESC') {
		 	delete query['sort_fop_mail_host_box_draft'];
		 } else {
			query['sort_fop_mail_host_box_draft'] = 'subject ASC';
		 }
		 reloadfop_mail_host_box_draft();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('subject')); ?>'><?php echo(_('subject')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_mail_host_box_draft']) && $_GET['sort_fop_mail_host_box_draft'] == 'subject ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_mail_host_box_draft']) && $_GET['sort_fop_mail_host_box_draft'] == 'subject DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_mail_host_box_draft_subject']) || isset($_GET['range_max_fop_mail_host_box_draft_subject']) || isset($_GET['deps_fop_mail_host_box_draft_subject']) || isset($_GET['fullsearch_fop_mail_host_box_draft_subject']) || isset($_GET['dynamic_fop_mail_host_box_draft_subject']) || isset($_GET['search_fop_mail_host_box_draft_subject']) || isset($_GET['searchnot_fop_mail_host_box_draft_subject']) || isset($_GET['filter_fop_mail_host_box_draft_subject'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['subject']['header'] = ob_get_contents(); ob_end_clean();
											$columns['subject']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['subject']['width']); ?>px; <?php if ($columns['subject']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='subject'><span class='overflow-text' title="<?php echo htmlentities($item['subject']); ?>"><?php echo htmlentities($item['subject']); ?></span></div><?php
											};
											$columns['subject']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='subject'
													data-order='<?php echo intval($columns['subject']['order']); ?>'
													data-width='<?php echo intval($columns['subject']['width']); ?>'
													data-collapsed='<?php echo intval($columns['subject']['collapsed']); ?>'
													style='width: <?php echo intval($columns['subject']['width']); ?>px; <?php if ($columns['subject']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='date'
												data-order='<?php echo intval($columns['date']['order']); ?>'
												data-width='<?php echo intval($columns['date']['width']); ?>'
												data-collapsed='<?php echo intval($columns['date']['collapsed']); ?>'
												style='width: <?php echo intval($columns['date']['width']); ?>px; <?php if ($columns['date']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_mail_host_box_draft(); 
		}}, 600);
		date_filter(win, 'fop_mail_host_box_draft', 'date', <?php echo htmlentities(json_encode(_('period'))); ?>, <?php echo htmlentities(json_encode(\FOP\I18n::getShortLocale())); ?>, <?php echo htmlentities(json_encode(_('dateformat_moment'))); ?>, function() { reloadfop_mail_host_box_draft();  reloadfop_mail_host_box_draft(); });
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_mail_host_box_draft'] == 'date ASC') {
			query['sort_fop_mail_host_box_draft'] = 'date DESC';
		 } else if (query['sort_fop_mail_host_box_draft'] == 'date DESC') {
		 	delete query['sort_fop_mail_host_box_draft'];
		 } else {
			query['sort_fop_mail_host_box_draft'] = 'date ASC';
		 }
		 reloadfop_mail_host_box_draft();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('date')); ?>'><?php echo(_('date')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_mail_host_box_draft']) && $_GET['sort_fop_mail_host_box_draft'] == 'date ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_mail_host_box_draft']) && $_GET['sort_fop_mail_host_box_draft'] == 'date DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_mail_host_box_draft_date']) || isset($_GET['range_max_fop_mail_host_box_draft_date']) || isset($_GET['deps_fop_mail_host_box_draft_date']) || isset($_GET['fullsearch_fop_mail_host_box_draft_date']) || isset($_GET['dynamic_fop_mail_host_box_draft_date']) || isset($_GET['search_fop_mail_host_box_draft_date']) || isset($_GET['searchnot_fop_mail_host_box_draft_date']) || isset($_GET['filter_fop_mail_host_box_draft_date'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['date']['header'] = ob_get_contents(); ob_end_clean();
											$columns['date']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['date']['width']); ?>px; <?php if ($columns['date']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='date'><span class='overflow-text' title="<?php echo htmlentities(($item['date']) ? strftime(_('datetimeformat_php2'), intval($item['date'])) : ''); ?>"><?php echo htmlentities(($item['date']) ? strftime(_('datetimeformat_php2'), intval($item['date'])) : ''); ?></span></div><?php
											};
											$columns['date']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='date'
													data-order='<?php echo intval($columns['date']['order']); ?>'
													data-width='<?php echo intval($columns['date']['width']); ?>'
													data-collapsed='<?php echo intval($columns['date']['collapsed']); ?>'
													style='width: <?php echo intval($columns['date']['width']); ?>px; <?php if ($columns['date']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='content'
												data-order='<?php echo intval($columns['content']['order']); ?>'
												data-width='<?php echo intval($columns['content']['width']); ?>'
												data-collapsed='<?php echo intval($columns['content']['collapsed']); ?>'
												style='width: <?php echo intval($columns['content']['width']); ?>px; <?php if ($columns['content']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_mail_host_box_draft(); 
		}});
		
		var el = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label fop-floatsorter\' style=\'width: calc(100% - 42px);\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(_('search')); ?></label></div>');
		win.append(el);
		var text = el.find('input');
		text.val(query['search_fop_mail_host_box_draft_content'])
		text.on('change keyup paste', function () { if (text.val()) { query['search_fop_mail_host_box_draft_content'] = text.val(); } else { delete query['search_fop_mail_host_box_draft_content']; } changed = true; });
		text.focus();
		text.select();
		text.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_mail_host_box_draft').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});

		var el2 = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(htmlentities(htmlentities(_('filter_contains_not')))); ?></label></div>');
		win.append(el2);
		var text2 = el2.find('input');
		text2.val(query['searchnot_fop_mail_host_box_draft_content'])
		text2.on('change keyup paste', function () { if (text2.val()) { query['searchnot_fop_mail_host_box_draft_content'] = text2.val(); } else { delete query['searchnot_fop_mail_host_box_draft_content']; } changed = true; });
		text2.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_mail_host_box_draft').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});
	
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_mail_host_box_draft'] == 'content ASC') {
			query['sort_fop_mail_host_box_draft'] = 'content DESC';
		 } else if (query['sort_fop_mail_host_box_draft'] == 'content DESC') {
		 	delete query['sort_fop_mail_host_box_draft'];
		 } else {
			query['sort_fop_mail_host_box_draft'] = 'content ASC';
		 }
		 reloadfop_mail_host_box_draft();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('content')); ?>'><?php echo(_('content')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_mail_host_box_draft']) && $_GET['sort_fop_mail_host_box_draft'] == 'content ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_mail_host_box_draft']) && $_GET['sort_fop_mail_host_box_draft'] == 'content DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_mail_host_box_draft_content']) || isset($_GET['range_max_fop_mail_host_box_draft_content']) || isset($_GET['deps_fop_mail_host_box_draft_content']) || isset($_GET['fullsearch_fop_mail_host_box_draft_content']) || isset($_GET['dynamic_fop_mail_host_box_draft_content']) || isset($_GET['search_fop_mail_host_box_draft_content']) || isset($_GET['searchnot_fop_mail_host_box_draft_content']) || isset($_GET['filter_fop_mail_host_box_draft_content'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['content']['header'] = ob_get_contents(); ob_end_clean();
											$columns['content']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['content']['width']); ?>px; <?php if ($columns['content']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='content'><?php 
	$html = preg_replace('/^<!DOCTYPE.+?>/m', '', \FOP\Sanitizers::htmlentities_decode($item['content'])); ?>
	<span style="display: block;" onmouseenter='handleHTMLOverlay(event, &apos;#overlayFormcontent<?php echo htmlentities($item['ID'] ?? 'fail'); ?>&apos;);' onmouseleave='handleHTMLOverlayFade(event, &apos;#overlayFormcontent<?php echo htmlentities($item['ID'] ?? 'fail'); ?>&apos;);' ng-non-bindable><?php echo htmlentities(mb_substr(preg_replace('/[ \t\r\n]+/', ' ', strip_tags(preg_replace('/<style.*?\/style>/s', '', html_entity_decode($item['content'])))), 0, 50) . (strlen(preg_replace('/[ \t\r\n]+/', ' ', strip_tags(preg_replace('/<style.*?\/style>/s', '', html_entity_decode($item['content']))))) >= 50 ? '...' : ''));  ?></span>
	<div class="overlay-iframe" id="overlayFormcontent<?php echo $item['ID'] ?? 'fail'; ?>">
		<div class="iframe-container" id="iframecontainer">
			<?php echo \FOP\Util::SanitizeUserHtml($html); ?>
		</div>
	</div>
</div><?php
											};
											$columns['content']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='content'
													data-order='<?php echo intval($columns['content']['order']); ?>'
													data-width='<?php echo intval($columns['content']['width']); ?>'
													data-collapsed='<?php echo intval($columns['content']['collapsed']); ?>'
													style='width: <?php echo intval($columns['content']['width']); ?>px; <?php if ($columns['content']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='contentSignature'
												data-order='<?php echo intval($columns['contentSignature']['order']); ?>'
												data-width='<?php echo intval($columns['contentSignature']['width']); ?>'
												data-collapsed='<?php echo intval($columns['contentSignature']['collapsed']); ?>'
												style='width: <?php echo intval($columns['contentSignature']['width']); ?>px; <?php if ($columns['contentSignature']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_mail_host_box_draft(); 
		}});
		
		var el = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label fop-floatsorter\' style=\'width: calc(100% - 42px);\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(_('search')); ?></label></div>');
		win.append(el);
		var text = el.find('input');
		text.val(query['search_fop_mail_host_box_draft_contentSignature'])
		text.on('change keyup paste', function () { if (text.val()) { query['search_fop_mail_host_box_draft_contentSignature'] = text.val(); } else { delete query['search_fop_mail_host_box_draft_contentSignature']; } changed = true; });
		text.focus();
		text.select();
		text.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_mail_host_box_draft').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});

		var el2 = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(htmlentities(htmlentities(_('filter_contains_not')))); ?></label></div>');
		win.append(el2);
		var text2 = el2.find('input');
		text2.val(query['searchnot_fop_mail_host_box_draft_contentSignature'])
		text2.on('change keyup paste', function () { if (text2.val()) { query['searchnot_fop_mail_host_box_draft_contentSignature'] = text2.val(); } else { delete query['searchnot_fop_mail_host_box_draft_contentSignature']; } changed = true; });
		text2.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_mail_host_box_draft').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});
	
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_mail_host_box_draft'] == 'contentSignature ASC') {
			query['sort_fop_mail_host_box_draft'] = 'contentSignature DESC';
		 } else if (query['sort_fop_mail_host_box_draft'] == 'contentSignature DESC') {
		 	delete query['sort_fop_mail_host_box_draft'];
		 } else {
			query['sort_fop_mail_host_box_draft'] = 'contentSignature ASC';
		 }
		 reloadfop_mail_host_box_draft();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('email_signature')); ?>'><?php echo(_('email_signature')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_mail_host_box_draft']) && $_GET['sort_fop_mail_host_box_draft'] == 'contentSignature ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_mail_host_box_draft']) && $_GET['sort_fop_mail_host_box_draft'] == 'contentSignature DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_mail_host_box_draft_contentSignature']) || isset($_GET['range_max_fop_mail_host_box_draft_contentSignature']) || isset($_GET['deps_fop_mail_host_box_draft_contentSignature']) || isset($_GET['fullsearch_fop_mail_host_box_draft_contentSignature']) || isset($_GET['dynamic_fop_mail_host_box_draft_contentSignature']) || isset($_GET['search_fop_mail_host_box_draft_contentSignature']) || isset($_GET['searchnot_fop_mail_host_box_draft_contentSignature']) || isset($_GET['filter_fop_mail_host_box_draft_contentSignature'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['contentSignature']['header'] = ob_get_contents(); ob_end_clean();
											$columns['contentSignature']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['contentSignature']['width']); ?>px; <?php if ($columns['contentSignature']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='contentSignature'><?php 
	$html = preg_replace('/^<!DOCTYPE.+?>/m', '', \FOP\Sanitizers::htmlentities_decode($item['contentSignature'])); ?>
	<span style="display: block;" onmouseenter='handleHTMLOverlay(event, &apos;#overlayFormcontentSignature<?php echo htmlentities($item['ID'] ?? 'fail'); ?>&apos;);' onmouseleave='handleHTMLOverlayFade(event, &apos;#overlayFormcontentSignature<?php echo htmlentities($item['ID'] ?? 'fail'); ?>&apos;);' ng-non-bindable><?php echo htmlentities(mb_substr(preg_replace('/[ \t\r\n]+/', ' ', strip_tags(preg_replace('/<style.*?\/style>/s', '', html_entity_decode($item['contentSignature'])))), 0, 50) . (strlen(preg_replace('/[ \t\r\n]+/', ' ', strip_tags(preg_replace('/<style.*?\/style>/s', '', html_entity_decode($item['contentSignature']))))) >= 50 ? '...' : ''));  ?></span>
	<div class="overlay-iframe" id="overlayFormcontentSignature<?php echo $item['ID'] ?? 'fail'; ?>">
		<div class="iframe-container" id="iframecontainer">
			<?php echo \FOP\Util::SanitizeUserHtml($html); ?>
		</div>
	</div>
</div><?php
											};
											$columns['contentSignature']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='contentSignature'
													data-order='<?php echo intval($columns['contentSignature']['order']); ?>'
													data-width='<?php echo intval($columns['contentSignature']['width']); ?>'
													data-collapsed='<?php echo intval($columns['contentSignature']['collapsed']); ?>'
													style='width: <?php echo intval($columns['contentSignature']['width']); ?>px; <?php if ($columns['contentSignature']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									

									// sort by order
									uasort($columns, function ($a, $b) {
										return $a['order'] - $b['order'];
									});
									?>
									<style type='text/css'>
										#fop_mail_host_box_draft-table .fop-table-header {
											height: <?php echo 32; ?>px;
										}
										#fop_mail_host_box_draft-table .fop-table-header .fop-table-column .title,
										#fop_mail_host_box_draft-table .fop-column-handle,
										#fop_mail_host_box_draft-table .fop-table-row,
										#fop_mail_host_box_draft-table .fop-table-row .fop-table-column,
										#fop_mail_host_box_draft-table .fop-table-column-multicontrol,
										#fop_mail_host_box_draft-table .fop-filter-button {
											height: 32px;
											line-height: 32px;
										}
										</style>
											<div class="fop-table" data-table-id="fop_mail_host_box_draft">
											<div class="fop-legend"></div>
											<div class="fop-filter-string-wrapper"><div class="fop-filter-string"><label>Filter:</label> <span><?php echo self::getFilterHTML($_GET); ?></span></div></div>
											
											<?php if (isset($_GET['select'])) { echo '<br>'; } ?>
											<div class="fop-table-header">
											<?php if (!isset($_GET['select'])) { ?>
												<div class="fop-table-column noprint" style="width: <?php echo json_encode($firstColumnWidth); ?>px;">
													
													<div class="fop-table-column-multicontrol">
													<label class="mdl-checkbox mdl-js-checkbox"  style='width: auto;' for="fop_mail_host_box_draft__all-checkbox">
														<input class="mdl-checkbox__input" id="fop_mail_host_box_draft__all-checkbox" type="checkbox" onchange="checkfop_mail_host_box_draft('all', 'ID', this.checked);">
														</label>
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon fop_mail_host_box_draft__mass-action" style='visibility: hidden;' onclick="$.get('DataView/Fop_mail_host_box_draft/permissions?id=' + checkfop_mail_host_box_draft(null, 'ID'), function (data) { for (var method in data) if (method != '__cnt') { var btn = $('[data-interaction-name=&quot;' + method + '&quot;]'); if (data[method] >= 1) btn.show(); else btn.hide(); btn.find('.cnt').text(data[method]); }; }); dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">more_vert</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterall" style="margin-right:auto; text-align:left;"
					onclick="for (key in query) if (key.indexOf('range_min_fop_mail_host_box_draft_') == 0 || key.indexOf('range_max_fop_mail_host_box_draft_') == 0 || key.indexOf('deps_fop_mail_host_box_draft_') == 0 || key.indexOf('fullsearch_fop_mail_host_box_draft_') == 0 || key.indexOf('dynamic_fop_mail_host_box_draft_') == 0 || key.indexOf('search_fop_mail_host_box_draft_') == 0 || key.indexOf('searchnot_fop_mail_host_box_draft_') == 0 || key.indexOf('filter_fop_mail_host_box_draft_') == 0) delete query[key]; reloadfop_mail_host_box_draft(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">list</i></span><span class="fop-menu-caption" title="<?php echo(_('view all elements')); ?>"><?php echo(_('view all elements')); ?> 
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filteronly" style="margin-right:auto; text-align:left;"
					onclick="query['filter_fop_mail_host_box_draft_ID'] = checkfop_mail_host_box_draft(null, 'ID'); delete query['page_fop_mail_host_box_draft']; reloadfop_mail_host_box_draft(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">arrow_forward</i></span><span class="fop-menu-caption" title="<?php echo(_('view only these elements')); ?>"><?php echo(_('view only these elements')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterrange" style="margin-right:auto; text-align:left;"
					onclick="
		var ticks = new IDList(checkfop_mail_host_box_draft(null, 'ID'));
		var range = prompt('Bitte geben Sie den Bereich ein', '1-' + ticks.count());
		var newticks = new IDList();
		if (range) {
			range = range.split('-');
			if (range.length == 1) {
				range.push(range[0]);
			}
			var skip = (range[0] || 1) - 1;
			var take = (range[1] || Infinity) - skip;
			for (var item of ticks.all()) {
				if (skip > 0) {
					skip--;
				} else if (take > 0) {
					newticks.push(item);
					take--;
				} else break;
			}
			checkfop_mail_host_box_draft(newticks, 'ID', 'set');
		} $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">colorize</i></span><span class="fop-menu-caption" title="<?php echo(_('limit range')); ?>"><?php echo(_('limit range')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true && (!\FOP\User::getIsGuest())) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;"
					onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return;$.get('Tables/Fop_mail_host_box_draft/delete?ajax&from=<?php echo urlencode(\FOP\Util::getBackUrl()); ?>&id=' + escape(checkfop_mail_host_box_draft(null, 'ID'))).then(function () { reloadfop_mail_host_box_draft(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?>
														</ul>
														<!-- column hide -->
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon" onclick="dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">visibility</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php foreach ($columns AS $col) { ?>
																<li class="mdl-list__item mdl-button" onclick="
																	var isVisible = this.firstElementChild.innerText !== 'clear';
																	this.firstElementChild.innerText = isVisible ? 'clear' : 'visibility'; // switch icon
																	tableColumnVisibility('fop_mail_host_box_draft', <?php echo htmlentities(json_encode($col['id'])); ?>, !isVisible); // the rest is up to a helper function in layout/tables.fop
																	">
																	<i class="material-icons"><?php if ($col['collapsed']) { echo 'clear'; } else { echo 'visibility'; }?></i>
																	<?php echo htmlentities($col['desc']); ?>
																</li>
															<?php } ?>
															<li class="mdl-list__item mdl-button" onclick="
																$.get('FOP/Index/dataview?data='+encodeURIComponent(JSON.stringify({dataview: 'fop_mail_host_box_draft', reset: true}))).then(function () { location.reload(); });
																">
																<i class="material-icons">refresh</i>
																<?php echo _('reset all'); ?>
															</li>
														</ul>
													</div>
												</div><?php }
												
												foreach ($columns AS $col) {
													// Spalten-Überschrift rendern
													echo $col['header'];
												} ?>
											 </div>
											
											<div class="fop-table-body" id="table_fop_mail_host_box_draft" <?php \EasyEditor\Navigation::printScroll('dv.Fop_mail_host_box_draft', '/* scroll horiz */ this.previousElementSibling.firstElementChild.style.marginLeft = \'-\' + this.scrollLeft + \'px\';
												/* scroll verti */
												var self = this;
												if (window.DataViewScrollReloadTimeout) clearTimeout(window.DataViewScrollReloadTimeout);
												window.DataViewScrollReloadTimeout = setTimeout(function () {
													var currentPage = parseInt(query[\'page_fop_mail_host_box_draft\'] || 0);
													var paddingTop = parseInt( self.lastElementChild.style.paddingTop, 10);
													var wantedPage = Math.max(0, currentPage + Math.floor((self.scrollTop - paddingTop) / ' . ($itemheight * $itemsperpage) . '));
													if (wantedPage != currentPage) {
														query[\'page_fop_mail_host_box_draft\'] = wantedPage;
														reloadfop_mail_host_box_draft(undefined, undefined, true);
													}
												}, 50);
											'); ?>>
												<div class="fop-table-body-inner" style="min-height: <?php echo 12 + $itemheight * ($itemcount + $additionalLines); ?>px; padding-top: <?php echo $itemheight * $itemsperpage * $page; ?>px;">
												<?php foreach($arr as $itempos => $item) {
													?>
													<div class="fop-table-row" style="" data-fop_mail_host_box_draft-id="<?php echo htmlentities($item['ID']); ?>"<?php if (isset($item['ID'])){
														if (isset($_GET['select']) && isset($_GET['from'])) {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) window.location.href=' . htmlentities(json_encode($_GET['from'] . '&colvalue=' . urlencode($item['ID']))) . ';" ';
														} else {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) open_url(reloadfop_mail_host_box_draft({action: \'open\', fop_table: \'fop_mail_host_box_draft\', fop_id: ' .  htmlentities(json_encode($item['ID'])) . ', fop_from: location.href}, true), false);"';
														}
													}?> >

													<?php if (!isset($_GET['select'])) { ?>
													<div class='fop-table-column noprint' style="width: <?php echo json_encode($firstColumnWidth); ?>px;" onclick="$(this).find('input[type=checkbox]').first().click(); event.stopPropagation();">
													<label onclick="event.stopPropagation();" class="mdl-checkbox mdl-js-checkbox fop_mail_host_box_draft__checkbox fop_mail_host_box_draft__checkbox fop_mail_host_box_draft__checkbox-ID-<?php echo htmlentities($item['ID']); ?>" style="width: auto;" for="fop_mail_host_box_draft__<?php echo htmlentities($itempos); ?>-checkbox">
													<input class="mdl-checkbox__input" id="fop_mail_host_box_draft__<?php echo htmlentities($itempos); ?>-checkbox" type="checkbox" onchange="<?php if (isset($item['ID'])) echo 'checkfop_mail_host_box_draft(' . htmlentities(json_encode($item['ID'])) . ', \'ID\', this.checked); ' ?>">
													</label><button type="button" class="mdl-button mdl-js-button mdl-button--icon fop_mail_host_box_draft__action" onclick="
														event.stopPropagation();
														dropDownFixPosition($(this), $(this).next());
														">
														<i class="material-icons">more_vert</i>
													</button><ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu" id="fop-scroll-menu-fop_mail_host_box_draft-action-<?php echo $item['ID'] ?? 0; ?>">
														<?php
		if(isset($item['ID']) && $item['operation::view']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="view" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\Fop_mail_host_box_draft::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick=" if (!event.ctrlKey) { open_url(reloadfop_mail_host_box_draft({action: 'open', fop_table: 'fop_mail_host_box_draft', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; } $(this).closest('.overlay').click(); return false;  
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">find_in_page</i></span><span class="fop-menu-caption" title="<?php echo(_('open')); ?>"><?php echo(_('open')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="edit" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\Fop_mail_host_box_draft::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">edit</i></span><span class="fop-menu-caption" title="<?php echo(_('edit')); ?>"><?php echo(_('edit')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && (!\FOP\User::getIsGuest())) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="create_fop_mail_host_box_draft_attachment_draft" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\Fop_mail_host_box_draft_attachment::createURL2(['column_draft' => $item['ID'], 'from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">create</i></span><span class="fop-menu-caption" title="<?php echo(sprintf(_('create %s'), _('Anhang'))); ?>"><?php echo(sprintf(_('create %s'), _('Anhang'))); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && (!\FOP\User::getIsGuest())) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="create_fop_mail_host_box_draft_recipient_draft" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\Fop_mail_host_box_draft_recipient::createURL2(['column_draft' => $item['ID'], 'from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">create</i></span><span class="fop-menu-caption" title="<?php echo(sprintf(_('create %s'), _('further recipients'))); ?>"><?php echo(sprintf(_('create %s'), _('further recipients'))); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::delete']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;" href="#"
				onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return false;   $.get('Tables/Fop_mail_host_box_draft/delete?ajax&id=<?php echo htmlentities($item['ID']);?>&from=<?php echo htmlentities(\FOP\Util::getBackUrl());?>').then(function () { reloadfop_mail_host_box_draft(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?></span>
			</a>
		<?php } ?>
													</ul><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="fop_mail_host_box_draft" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="edit" href="<?php echo htmlentities(\TablesRouter\Fop_mail_host_box_draft::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();    reloadfop_mail_host_box_draft();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('edit')); ?>">
				<i class="material-icons">edit</i>
			</a><?php } ?><?php
		if(isset($item['ID']) && $item['operation::view']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="fop_mail_host_box_draft" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="view" href="<?php echo htmlentities(\TablesRouter\Fop_mail_host_box_draft::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();  if (!event.ctrlKey) { open_url(reloadfop_mail_host_box_draft({action: 'open', fop_table: 'fop_mail_host_box_draft', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; }  reloadfop_mail_host_box_draft();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('open')); ?>">
				<i class="material-icons">find_in_page</i>
			</a><?php } ?>
													</div><?php } ?><?php
													
													foreach ($columns AS $col) {
														$col['render']($item);
													}
													?></div>
												 <?php }?>

													</div>
												</div>

												
												
												</div><?php
												
	
    
  }

  public static function getidsAction($col) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
			$q = \FOP\Database::query('SELECT t.'.qi($col).' '.self::getSQL($_GET));
			$result = new \FOP\IDList();
			while ($item = $q->fetchColumn()) {
				$result->push($item);
			}
			die($result->toString());

    
  }

  public static function permissionsAction($id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		$ids = new \FOP\IDList($id);
		header('Content-Type: application/json');
		
		$perms = \FOP\Database::query('SELECT COUNT(*) AS __cnt, SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filteronly').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterrange').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterall').', SUM(CASE ('.(\FOP\User::getIsGuest() ? 'false' : 'true').') WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('delete').' FROM '.qi('fop_mail_host_box_draft').' WHERE ' . $ids->toSQL(qi('ID')))->fetch(\PDO::FETCH_ASSOC);
		
		return $perms;
	
    
  }

  public static function getSQL($params) { 
    
    
    // --- BLOCK: dependency-fop_mail_host_box_draft ---
    
		if (isset($params['select']) && $params['select'] == 'fop_mail_host_box_draft') {
			$deps = [];
		}
	
    // --- BLOCK: main ---
    
								// returns a sql snippet 'FROM (...) AS t WHERE' where you can prepend your select clauses and append your ORDER LIMIT
								$sql = 'FROM (SELECT /* ID */ '.qi('ID').' AS '.qi('ID').',
									/* content */ '.qi('content').' AS '.qi('content').',
									/* contentSignature */ '.qi('contentSignature').' AS '.qi('contentSignature').',
									/* date */ '.qi('date').' AS '.qi('date').',
									/* mailbox */ '.qi('mailbox').' AS '.qi('mailbox').',
									/* mailbox::canView */ '.qi('ref:mailbox').'.'.qi('mailbox:canView').' AS '.qi('mailbox::canView').',
									/* mailbox::description */ '.qi('ref:mailbox').'.'.qi('mailbox:description').' AS '.qi('mailbox::description').',
									/* operation::create */ '.(\FOP\User::getIsGuest() ? 'false' : 'true').' AS '.qi('operation::create').',
									/* operation::delete */ '.(\FOP\User::getIsGuest() ? 'false' : 'true').' AS '.qi('operation::delete').',
									/* operation::edit */ '.(\FOP\User::getIsGuest() ? 'false' : 'true').' AS '.qi('operation::edit').',
									/* operation::fop_mail_host_box_draft */ ' . (!\FOP\User::getIsGuest() ? 1 : 0) . ' AS '.qi('operation::fop_mail_host_box_draft').',
									/* operation::index */ ' . (!\FOP\User::getIsGuest() ? 1 : 0) . ' AS '.qi('operation::index').',
									/* operation::view */ '.(\FOP\User::getIsGuest() ? 'false' : 'true').' AS '.qi('operation::view').',
									/* receiver */ '.qi('receiver').' AS '.qi('receiver').',
									/* subject */ '.qi('subject').' AS '.qi('subject').',
									1
								FROM '.qi('fop_mail_host_box_draft').' '.qi('fop_mail_host_box_draft').'
								LEFT JOIN (SELECT '.qi('ID').' AS '.qi('mailbox:ID').', '.qi('fop_mail_host_box').'.'.qi('from_address').' AS '.qi('mailbox:description').', ((CASE WHEN FALSE THEN TRUE ELSE NOT (('.qi('fop_mail_host_box').'.'.qi('fopuser').') <> ('.\FOP\Database::sessionVarSQL('user').')) END)) AS '.qi('mailbox:canView').' FROM '.qi('fop_mail_host_box').') '.qi('ref:mailbox').' ON '.qi('ref:mailbox').'.'.qi('mailbox:ID').' = '.qi('mailbox').'
								WHERE (('.(\FOP\User::getIsGuest() ? 'false' : 'true').'))
									AND (' . (isset($_GET['select']) && $_GET['select'] == 'fop_mail_host_box_draft' ? 'TRUE' : 'TRUE') . ')) AS t
								WHERE ' . (isset($params['range_min_fop_mail_host_box_draft_date']) ? ($params['range_min_fop_mail_host_box_draft_date'] !== '' && is_numeric($params['range_min_fop_mail_host_box_draft_date']) ? 't.'.qi('date').' >= ' . \FOP\Database::quote($params['range_min_fop_mail_host_box_draft_date']) . ' AND ' : '') : '') . 
								(isset($params['range_max_fop_mail_host_box_draft_date']) ? ($params['range_max_fop_mail_host_box_draft_date'] !== '' && is_numeric($params['range_max_fop_mail_host_box_draft_date']) ? 't.'.qi('date').' <= ' . \FOP\Database::quote($params['range_max_fop_mail_host_box_draft_date']) . ' AND ' : '') : '') . 
								(isset($params['filter_fop_mail_host_box_draft_receiver']) ? ($params['filter_fop_mail_host_box_draft_receiver'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_mail_host_box_draft_receiver']))->toSQL('t.'.qi('receiver').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_mail_host_box_draft_mailbox']) ? ($params['filter_fop_mail_host_box_draft_mailbox'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_mail_host_box_draft_mailbox']))->toSQL('t.'.qi('mailbox').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_mail_host_box_draft_subject']) ? ($params['filter_fop_mail_host_box_draft_subject'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_mail_host_box_draft_subject']))->toSQL('t.'.qi('subject').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_mail_host_box_draft_date']) ? ($params['filter_fop_mail_host_box_draft_date'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_mail_host_box_draft_date']))->toSQL('t.'.qi('date').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_mail_host_box_draft_content']) ? ($params['filter_fop_mail_host_box_draft_content'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_mail_host_box_draft_content']))->toSQL('t.'.qi('content').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_mail_host_box_draft_contentSignature']) ? ($params['filter_fop_mail_host_box_draft_contentSignature'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_mail_host_box_draft_contentSignature']))->toSQL('t.'.qi('contentSignature').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_mail_host_box_draft_ID']) ? ($params['filter_fop_mail_host_box_draft_ID'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_mail_host_box_draft_ID']))->toSQL('t.'.qi('ID').'') . ') AND ') : '') : '') . 
								(isset($params['search_fop_mail_host_box_draft_receiver']) ? 't.'.qi('receiver').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_mail_host_box_draft_receiver'] . '%') . ' AND ' : '') . 
								(isset($params['search_fop_mail_host_box_draft_subject']) ? 't.'.qi('subject').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_mail_host_box_draft_subject'] . '%') . ' AND ' : '') . 
								(isset($params['search_fop_mail_host_box_draft_content']) ? 't.'.qi('content').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_mail_host_box_draft_content'] . '%') . ' AND ' : '') . 
								(isset($params['search_fop_mail_host_box_draft_contentSignature']) ? 't.'.qi('contentSignature').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_mail_host_box_draft_contentSignature'] . '%') . ' AND ' : '') . 
								(isset($params['searchnot_fop_mail_host_box_draft_receiver']) ? 'NOT t.'.qi('receiver').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['searchnot_fop_mail_host_box_draft_receiver'] . '%') . ' AND ' : '') . 
								(isset($params['searchnot_fop_mail_host_box_draft_subject']) ? 'NOT t.'.qi('subject').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['searchnot_fop_mail_host_box_draft_subject'] . '%') . ' AND ' : '') . 
								(isset($params['searchnot_fop_mail_host_box_draft_content']) ? 'NOT t.'.qi('content').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['searchnot_fop_mail_host_box_draft_content'] . '%') . ' AND ' : '') . 
								(isset($params['searchnot_fop_mail_host_box_draft_contentSignature']) ? 'NOT t.'.qi('contentSignature').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['searchnot_fop_mail_host_box_draft_contentSignature'] . '%') . ' AND ' : '') . 
								(isset($params['search_fop_mail_host_box_draft']) ? '(' . 't.'.qi('receiver').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_mail_host_box_draft'] . '%') . ' OR ' . 't.'.qi('subject').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_mail_host_box_draft'] . '%') . ' OR ' . 't.'.qi('content').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_mail_host_box_draft'] . '%') . ' OR ' . 't.'.qi('contentSignature').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_mail_host_box_draft'] . '%') . ') AND ' : '') . 
								'
								 TRUE ';
								return $sql;
	
    
  }

  public static function getfilter_fop_mail_host_box_draft_mailboxItemsByStringAction($fstr) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		// Auf aktive DataView-Items einschränken
		$params = $_GET;
		unset($params['filter_fop_mail_host_box_draft_mailbox']);
		return \Types\Fop_mail_host_box_send::getItems(null, -1, $fstr, ''.qi('ID').' IN (SELECT DISTINCT t.'.qi('mailbox').''.self::getSQL($params).')');
	

    
  }

  public static function getData($sqladdon, $params, $stream = false ) { 
    
    
    // --- BLOCK: main ---
    
								$sql = self::getSQL($params);

								$order = (\FOP\Util::array_value(array(
									'receiver ASC' => 'ORDER BY t.'.qi('receiver').' ASC',
									'content ASC' => 'ORDER BY t.'.qi('content').' ASC',
									'contentSignature ASC' => 'ORDER BY t.'.qi('contentSignature').' ASC',
									'subject ASC' => 'ORDER BY t.'.qi('subject').' ASC',
									'date ASC' => 'ORDER BY t.'.qi('date').' ASC',
									'receiver DESC' => 'ORDER BY t.'.qi('receiver').' DESC',
									'content DESC' => 'ORDER BY t.'.qi('content').' DESC',
									'contentSignature DESC' => 'ORDER BY t.'.qi('contentSignature').' DESC',
									'subject DESC' => 'ORDER BY t.'.qi('subject').' DESC',
									'date DESC' => 'ORDER BY t.'.qi('date').' DESC',
									'' => ''), isset($params['sort_fop_mail_host_box_draft']) ? $params['sort_fop_mail_host_box_draft'] : '') ?: '');
								// wenn sqladdon bereits ein ORDER enthält, kein order aufbauen
								if (strpos($sqladdon, 'ORDER') !== false) {
									$order = '';
								}
								if ($stream) {
									// als Stream (währenddessen darf keine weitere SQL-Query laufen) für große Datenmengen und Statistiken
									$result = (function () use ($sql, $order, $sqladdon) {
										$stream = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
										while ($item = $stream->fetch(\PDO::FETCH_ASSOC)) {
											$item['receiver'] = \FOP\Sanitizers::a_text($item['receiver']);
											$item['mailbox'] = \FOP\Sanitizers::null_converter($item['mailbox']);
											$item['date'] = intval($item['date']);
											
											yield $item;
										}
									})();
								} else {
									// als RAM-Array
									$result = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
									$arr = $result->fetchAll(\PDO::FETCH_ASSOC);
									$itemcount = count($arr);

									foreach($arr as $i => &$item){
										$item['receiver'] = \FOP\Sanitizers::a_text($item['receiver']);
										$item['mailbox'] = \FOP\Sanitizers::null_converter($item['mailbox']);
										$item['date'] = intval($item['date']);
										
									}
									unset($item);

									$result = ["items" => $arr, "itemcount" => $itemcount];

									
								}

								return $result;
	
    
  }

  public static function getFilterHTML($params, $delimiter = ', ' , $showButton = true ) { 
    
    
    // --- BLOCK: main ---
    
		// Contract: ist showButton == false, sollten keine HTML-Tags im Output enthalten sein (Verwendung in Dateinamen!!)
		$filters = [];
		
	
	if ( // Corner Case: Monat
		isset($params['range_min_fop_mail_host_box_draft_date'])
		&& isset($params['range_max_fop_mail_host_box_draft_date'])
		&& (date('d', $params['range_min_fop_mail_host_box_draft_date']) == '01') //check first day of month
		&& (date('d', $params['range_max_fop_mail_host_box_draft_date']) == date('t', $params['range_max_fop_mail_host_box_draft_date'])) //check last day of month
		&& (date('Y-m', $params['range_min_fop_mail_host_box_draft_date']) == date('Y-m', $params['range_max_fop_mail_host_box_draft_date'])) //check if same year and month
	) {
		array_push($filters, [
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_mail_host_box_draft_date&apos;] = &apos;'.strtotime('first day of last month', $params['range_min_fop_mail_host_box_draft_date']).'&apos;;
				query[&apos;range_max_fop_mail_host_box_draft_date&apos;] = &apos;'.strtotime('last day of last month', $params['range_min_fop_mail_host_box_draft_date']).'&apos;;
				reloadfop_mail_host_box_draft(); ">remove_circle_outline</i>' : ''),
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_mail_host_box_draft_date&apos;] = &apos;'.strtotime('first day of next month', $params['range_min_fop_mail_host_box_draft_date']).'&apos;;
				query[&apos;range_max_fop_mail_host_box_draft_date&apos;] = &apos;'.strtotime('last day of next month', $params['range_min_fop_mail_host_box_draft_date']).'&apos;;
				reloadfop_mail_host_box_draft(); ">add_circle_outline</i>' : ''),
			htmlentities(_('date') . ': ' . strftime('%B', $params['range_min_fop_mail_host_box_draft_date']) . ' ' . date('Y', $params['range_min_fop_mail_host_box_draft_date']))
		]);
	} else if ( // Corner Case: Tag
		isset($params['range_min_fop_mail_host_box_draft_date'])
		&& isset($params['range_max_fop_mail_host_box_draft_date'])
		&& (date('Y-m-d', $params['range_min_fop_mail_host_box_draft_date']) == (date('Y-m-d', $params['range_max_fop_mail_host_box_draft_date'])))
	) {
		array_push($filters, [
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_mail_host_box_draft_date&apos;] = &apos;'.strtotime('last day', $params['range_min_fop_mail_host_box_draft_date']).'&apos;;
				query[&apos;range_max_fop_mail_host_box_draft_date&apos;] = &apos;'.strtotime('last day', $params['range_min_fop_mail_host_box_draft_date']).'&apos;;
				reloadfop_mail_host_box_draft(); ">remove_circle_outline</i>' : ''),
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_mail_host_box_draft_date&apos;] = &apos;'.strtotime('next day', $params['range_min_fop_mail_host_box_draft_date']).'&apos;;
				query[&apos;range_max_fop_mail_host_box_draft_date&apos;] = &apos;'.strtotime('next day', $params['range_min_fop_mail_host_box_draft_date']).'&apos;;
				reloadfop_mail_host_box_draft(); ">add_circle_outline</i>' : ''),
			htmlentities(_('date') . ': ' . date('d.m.Y', $params['range_min_fop_mail_host_box_draft_date']))
		]);
	} else if ( // Corner Case: Jahr
		isset($params['range_min_fop_mail_host_box_draft_date'])
		&& isset($params['range_max_fop_mail_host_box_draft_date'])
		&& (date('Y', $params['range_min_fop_mail_host_box_draft_date']) == (date('Y', $params['range_max_fop_mail_host_box_draft_date'])))
		&& ((date('m-d', $params['range_min_fop_mail_host_box_draft_date']) == '01-01'))
		&& ((date('m-d', $params['range_max_fop_mail_host_box_draft_date']) == '12-31'))
	) {
		array_push($filters, [
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_mail_host_box_draft_date&apos;] = &apos;'.strtotime('first day of January last year', $params['range_min_fop_mail_host_box_draft_date']).'&apos;;
				query[&apos;range_max_fop_mail_host_box_draft_date&apos;] = &apos;'.strtotime('last day of December last year', $params['range_min_fop_mail_host_box_draft_date']).'&apos;;
				reloadfop_mail_host_box_draft(); ">remove_circle_outline</i>' : ''),
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_mail_host_box_draft_date&apos;] = &apos;'.strtotime('first day of January next year', $params['range_min_fop_mail_host_box_draft_date']).'&apos;;
				query[&apos;range_max_fop_mail_host_box_draft_date&apos;] = &apos;'.strtotime('last day of December next year', $params['range_min_fop_mail_host_box_draft_date']).'&apos;;
				reloadfop_mail_host_box_draft(); ">add_circle_outline</i>' : ''),
			htmlentities(_('date') . ': ' . date('Y', $params['range_min_fop_mail_host_box_draft_date']))
		]);
	} else if ( // Corner Case: Quartal
		isset($params['range_min_fop_mail_host_box_draft_date'])
		&& isset($params['range_max_fop_mail_host_box_draft_date'])
		&& ( (
		 ((date('m-d', $params['range_min_fop_mail_host_box_draft_date']) == '01-01'))
		&& ((date('m-d', $params['range_max_fop_mail_host_box_draft_date']) == '03-31')) )
		|| (
		 ((date('m-d', $params['range_min_fop_mail_host_box_draft_date']) == '04-01'))
		&& ((date('m-d', $params['range_max_fop_mail_host_box_draft_date']) == '06-30')) )
		|| (
		 ((date('m-d', $params['range_min_fop_mail_host_box_draft_date']) == '07-01'))
		&& ((date('m-d', $params['range_max_fop_mail_host_box_draft_date']) == '09-30')) )
		|| (
		 ((date('m-d', $params['range_min_fop_mail_host_box_draft_date']) == '10-01'))
		&& ((date('m-d', $params['range_max_fop_mail_host_box_draft_date']) == '12-31')) )
	) ) {
		array_push($filters, [
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
					query[&apos;range_min_fop_mail_host_box_draft_date&apos;] = &apos;'.strtotime('first day of -3 months', $params['range_min_fop_mail_host_box_draft_date']).'&apos;;
					query[&apos;range_max_fop_mail_host_box_draft_date&apos;] = &apos;'.strtotime('last day of -3 months', $params['range_max_fop_mail_host_box_draft_date']).'&apos;;
					reloadfop_mail_host_box_draft(); ">remove_circle_outline</i>' : ''),
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_mail_host_box_draft_date&apos;] = &apos;'.strtotime('first day of +3 months', $params['range_min_fop_mail_host_box_draft_date']).'&apos;;
				query[&apos;range_max_fop_mail_host_box_draft_date&apos;] = &apos;'.strtotime('last day of +3 months', $params['range_max_fop_mail_host_box_draft_date']).'&apos;;
				reloadfop_mail_host_box_draft(); ">add_circle_outline</i>' : ''),	
			htmlentities(_('date') . ': Q' . (ceil((date('m', $params['range_min_fop_mail_host_box_draft_date']))/3)) . ' (' . date('d.m.', $params['range_min_fop_mail_host_box_draft_date']) . ' - ' . date('d.m.Y', $params['range_max_fop_mail_host_box_draft_date']) . ')')
		]);
	}
	else if (isset($params['range_min_fop_mail_host_box_draft_date']) && isset($params['range_max_fop_mail_host_box_draft_date'])) {
		array_push($filters, _('date') . ': ' . (($params['range_min_fop_mail_host_box_draft_date']) ? strftime(_('datetimeformat_php2'), intval($params['range_min_fop_mail_host_box_draft_date'])) : '') . ' ' . _('filters_between') . ' ' . (($params['range_max_fop_mail_host_box_draft_date']) ? strftime(_('datetimeformat_php2'), intval($params['range_max_fop_mail_host_box_draft_date'])) : ''));
	} else if (isset($params['range_min_fop_mail_host_box_draft_date'])) {
		array_push($filters, _('date') . ': ' . _('filters_from') . ' ' . (($params['range_min_fop_mail_host_box_draft_date']) ? strftime(_('datetimeformat_php2'), intval($params['range_min_fop_mail_host_box_draft_date'])) : ''));
	} else if (isset($params['range_max_fop_mail_host_box_draft_date'])) {
		array_push($filters, _('date') . ': ' . _('filters_to') . ' ' . (($params['range_max_fop_mail_host_box_draft_date']) ? strftime(_('datetimeformat_php2'), intval($params['range_max_fop_mail_host_box_draft_date'])) : ''));
	}if (isset($params['filter_fop_mail_host_box_draft_receiver'])) {
		if ($params['filter_fop_mail_host_box_draft_receiver'] == '_null') {
			array_push($filters, _('recipient') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_mail_host_box_draft_receiver']))->all() AS $val) {
				$value = $val;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('recipient') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_mail_host_box_draft_subject'])) {
		if ($params['filter_fop_mail_host_box_draft_subject'] == '_null') {
			array_push($filters, _('subject') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_mail_host_box_draft_subject']))->all() AS $val) {
				$value = $val;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('subject') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_mail_host_box_draft_date'])) {
		if ($params['filter_fop_mail_host_box_draft_date'] == '_null') {
			array_push($filters, _('date') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_mail_host_box_draft_date']))->all() AS $val) {
				$value = ($val) ? strftime(_('datetimeformat_php2'), intval($val)) : '';
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('date') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_mail_host_box_draft_content'])) {
		if ($params['filter_fop_mail_host_box_draft_content'] == '_null') {
			array_push($filters, _('content') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_mail_host_box_draft_content']))->all() AS $val) {
				$value = mb_substr(preg_replace('/[ \t\r\n]+/', ' ', strip_tags(preg_replace('/<style.*?\/style>/s', '', html_entity_decode($val)))), 0, 20) . (strlen($val) >= 20 ? '...' : '');
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('content') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_mail_host_box_draft_contentSignature'])) {
		if ($params['filter_fop_mail_host_box_draft_contentSignature'] == '_null') {
			array_push($filters, _('email_signature') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_mail_host_box_draft_contentSignature']))->all() AS $val) {
				$value = mb_substr(preg_replace('/[ \t\r\n]+/', ' ', strip_tags(preg_replace('/<style.*?\/style>/s', '', html_entity_decode($val)))), 0, 20) . (strlen($val) >= 20 ? '...' : '');
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('email_signature') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_mail_host_box_draft_mailbox'])) {
		if ($params['filter_fop_mail_host_box_draft_mailbox'] == '_null') {
			array_push($filters, _('mailbox') . ': ' . _(''));
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_mail_host_box_draft_mailbox']))->all() AS $val) {
				$value = 
  \FOP\Database::query('SELECT '.qi('fop_mail_host_box').'.'.qi('from_address').' AS description FROM '.qi('fop_mail_host_box').' WHERE '.qi('ID').' = ' . \FOP\Database::quote($val))->fetchColumn() ?: _('')
;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('mailbox') . ': ' . implode(', ', $values));
		}
	}if (isset($params['search_fop_mail_host_box_draft_receiver'])) {
		array_push($filters, _('receiver') . ' ' . _('filter_contains') . ' ' . $params['search_fop_mail_host_box_draft_receiver']);
	}if (isset($params['search_fop_mail_host_box_draft_subject'])) {
		array_push($filters, _('subject') . ' ' . _('filter_contains') . ' ' . $params['search_fop_mail_host_box_draft_subject']);
	}if (isset($params['search_fop_mail_host_box_draft_content'])) {
		array_push($filters, _('content') . ' ' . _('filter_contains') . ' ' . $params['search_fop_mail_host_box_draft_content']);
	}if (isset($params['search_fop_mail_host_box_draft_contentSignature'])) {
		array_push($filters, _('contentSignature') . ' ' . _('filter_contains') . ' ' . $params['search_fop_mail_host_box_draft_contentSignature']);
	}if (isset($params['searchnot_fop_mail_host_box_draft_receiver'])) {
		array_push($filters, _('receiver') . ' ' . _('filter_contains_not') . ' ' . $params['searchnot_fop_mail_host_box_draft_receiver']);
	}if (isset($params['searchnot_fop_mail_host_box_draft_subject'])) {
		array_push($filters, _('subject') . ' ' . _('filter_contains_not') . ' ' . $params['searchnot_fop_mail_host_box_draft_subject']);
	}if (isset($params['searchnot_fop_mail_host_box_draft_content'])) {
		array_push($filters, _('content') . ' ' . _('filter_contains_not') . ' ' . $params['searchnot_fop_mail_host_box_draft_content']);
	}if (isset($params['searchnot_fop_mail_host_box_draft_contentSignature'])) {
		array_push($filters, _('contentSignature') . ' ' . _('filter_contains_not') . ' ' . $params['searchnot_fop_mail_host_box_draft_contentSignature']);
	}
		if (count($filters)) {
			$result = implode($delimiter, array_map(function ($filter) {
				if (is_array($filter)) {
					return implode('', $filter);
				}
				return htmlentities($filter);
			}, $filters))
			// Button, um Filter zu entfernen
			. ($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="for (var q in query) {if (q.includes(\'_fop_mail_host_box_draft_\')) delete query[q];} reloadfop_mail_host_box_draft(); ">clear</i>' : '');
		} else {
			$result = _('no_filter');
		}
		return $result;
	
    
  }

  public static function openAction($fop_table, $fop_id, $fop_from) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    

if ($fop_table == 'fop_mail_host_box_draft') {
	\FOP\Session::setPayload('dv-fop_mail_host_box_draft', [
		'id' => 'fop_mail_host_box_draft',
		'tbl' => 'fop_mail_host_box_draft',
		'idcol' => 'ID',
		'prev' => \DataViewRouter\Fop_mail_host_box_draft::stepURL('fop_mail_host_box_draft', 'XXX', -1),
		'next' => \DataViewRouter\Fop_mail_host_box_draft::stepURL('fop_mail_host_box_draft', 'XXX',  1),
		'from' => $fop_from
	]);
	
	if ($fop_id == '_') return; // nur Rückreferenz setzen, nicht öffnen
	$params = [];
	if (isset($_GET['popup'])) $params['popup'] = true;
	if (isset($_GET['from'])) $params['from'] = $_GET['from'];
	$params['id'] = $fop_id;
	
	$url = \TablesRouter\Fop_mail_host_box_draft::viewURL2($params);
	header('Location: ' . $url);
}

die();
    
  }

  public static function stepAction($tbl, $id, $step) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
	$dv = \FOP\Session::getPayload('dv-'.$tbl);
	$url = $dv['from'];
	$parts = parse_url($url);
	parse_str($parts['query'], $query);
	$data = self::getData('', $query);
	$col = $dv['idcol'];
	$ids = array_map(function ($x) use ($col) {return $x[$col];}, $data['items']);
	if (!count($ids)) {
		header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])));
		die();
	}
	$idx = array_search($id, $ids);
	$idx += count($ids) + $step;
	$idx = $idx % count($ids);
	header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])) . '/view?id=' . urlencode($ids[$idx]));
	die();

    
  }


  
  

  
  
}



